#!/bin/bash
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
INSTALLDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )"/../.. && pwd )"
. /etc/os-release
OS=$ID


echo "    --  Loading database entries for migration "
rm -rf /tmp/finalbase.ldif

ldapsearch -x -D cn=admin,dc=ipconnect,dc=fr -w THZVxLNpC62KeHQ3 -LLL -b ou=ipc,dc=ipconnect,dc=fr > /tmp/base.ldif

cat > /tmp/header.ldif <<EOF
dn: dc=ipconnect,dc=fr
objectClass: dcObject
objectClass: organization
dc: ipconnect
o: ipconnect

EOF

cat /tmp/header.ldif /tmp/base.ldif > /tmp/finalbase.ldif


echo "    --  Updating LDAP structure and password"
systemctl stop slapd
rm -rf /var/lib/ldap/*

mkdir -p /var/lib/ldap
cat > /var/lib/ldap/DB_CONFIG <<EOF
set_cachesize 0 268435456 1
set_lg_regionmax 262144
set_lg_bsize 2097152     
EOF

if [ $OS = "centos" ]
then
    rm -rf /etc/openldap/slapd.d/cn\=config*
    slapadd -n0 -F /etc/openldap/slapd.d -l $DIR/config_centos.ldif
    chown -R ldap:ldap /etc/openldap/slapd.d
else
    rm -rf /etc/ldap/slapd.d/cn\=config*
    slapadd -n0 -F /etc/ldap/slapd.d -l $DIR/config_debian.ldif
    chown -R openldap:openldap /etc/ldap/slapd.d
fi

echo "    --  Updating databases"
if [ $OS = "centos" ]
then
    slapadd -n2 -F /etc/openldap/slapd.d -l /tmp/finalbase.ldif
    chown -R ldap:ldap /var/lib/ldap
else
    slapadd -n1 -F /etc/ldap/slapd.d -l /tmp/finalbase.ldif
    chown -R openldap:openldap /var/lib/ldap
fi
systemctl start slapd



php $DIR/reworkcontacts.php